(function (sugo) {
               sugo.enable_page_event = $sugo_enable_page_event$;
               if (window.sugo && sugo.enable_page_event) {
                   sugo.stayTime();
               }
               sugo.auto_track = '$sugo_auto_track$';
               sugo.single_code = '';
               sugo.relative_path = '$sugo_relative_path$';
               sugo.url = '$sugo_url$';
               sugo.all_page_info = $all_page_info$;
               sugo.init = {
                    'code':  '$sugo_init_code$',
                    'page_name':  '$sugo_init_page_name$',
                    'page_category':  '$sugo_init_page_category$'
               };
               sugo.view_props = {};
               sugo.rawTrack = function (event_id, event_name, props) {
                    if (!props) {
                       props = {};
                    }
                    if(sugo.single_code) {
                     props.$sugo_path_name$ = sugo.relative_path +  '##' + sugo.single_code;
                    } else {
                     props.$sugo_path_name$ = sugo.relative_path;
                    }

                    if (!props.$sugo_page_name$ && sugo.init.page_name) {
                       props.$sugo_page_name$ = sugo.init.page_name;
                    }
                    if (!props.$sugo_page_category_key$ && sugo.init.page_category) {
                       props.$sugo_page_category_key$ = sugo.init.page_category;
                    }
                    window.sugoEventListener.track(event_id, event_name, JSON.stringify(props));
               };
               sugo.track = function (event_name, props) {
                   sugo.rawTrack('', event_name, props);
               };
               sugo.timeEvent = function (event_name) {
                   window.sugoEventListener.timeEvent(event_name);
               };

               sugo.registerSuperProperties = function(props) {
                       window.sugoEventListener.registerSuperProperties(JSON.stringify(props));
               };
               sugo.login = function(key, value) {
                   window.sugoEventListener.login(key, value)
               };
               sugo.logout = function(key, value) {
                   window.sugoEventListener.logout()
               };
               sugo.browser = function(){
                  if (sugo.enable_page_event) {
                      var ele = document.getElementById("eventdataid");
                      if (ele != null){
                          var value = ele.getAttribute("value");
                          if (value != null){
                               sugo.view_props["business_attribute"] = value;
                          }
                      }
                      var title = document.title;
                      if (title != null){
                           sugo.view_props["title"] = title;
                           sugo.view_props["page_name"] = title;
                      }
                      var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                      debugger;
                      sugo.track('浏览', tmp_props);
                      sugo.enter_time = new Date().getTime();
                  }
               };
               sugo.browser();
               sugo.stayTime = function(){
                 var tmp_duration = (new Date().getTime() - sugo.enter_time) / 1000;
                 var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                 tmp_props.duration = tmp_duration;
                 sugo.track('停留', tmp_props);
               };
               if (sugo && sugo.init.code) {
                      var view_props = {};
                      try {
                          var init_code = new Function('sugo', sugo.init.code);
                          view_props = init_code(sugo);
                      } catch (e) {
                          console.log(sugo.init.code);
                          view_props = {};
                      }
                      sugo.view_props = Object.assign({}, sugo.view_props, view_props);
                }
               if (!window.sugo && sugo.enable_page_event) {
                   window.addEventListener('unload', function (e) {
                       var tmp_duration = (new Date().getTime() - sugo.enter_time) / 1000;
                       var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                       tmp_props.duration = tmp_duration;
                       sugo.track('停留', tmp_props);
                   });
               }
               sugo.current_page = sugo.relative_path;
               sugo.h5_event_bindings = $sugo_h5_event_bindings$;
               sugo.sugo_hashcode = $sugo_hashcode$;
               sugo.current_event_bindings = {};
               for (var i = 0; i < sugo.h5_event_bindings.length; i++) {
                   var b_event = sugo.h5_event_bindings[i];
                   if (b_event.target_activity === sugo.current_page || b_event.cross_page || b_event.target_activity === sugo.relative_path) {
                       var b_key = JSON.stringify(b_event.path);
                       sugo.current_event_bindings[b_key] = b_event;
                   }
               }

               sugo.isElementInViewport = function (rect) {
                   return ( rect.top >= 0 && rect.left >= 0 && rect.bottom <= sugo.clientHeight && rect.right <= sugo.clientWidth);
               };
               sugo.excludeControl = ['symbol', 'SCRIPT'];
               sugo.handleNodeChild = function(childrens, nodeJSONArray, parent_path) {
                   for (var i = 0; i < childrens.length; i++) {
                       var nodeChildren = childrens[i];
                       if(!sugo.isVisible(nodeChildren)){
                           continue;
                       }
                       if (sugo.excludeControl.indexOf(nodeChildren.tagName) >= 0) {
                           continue;
                       }
                       var rect = {top:0, left:0, width:0, height:0};
                       if(nodeChildren.tagName == 'AREA'){
                           rect = sugo.getSpecialElementRect(nodeChildren);
                       }else{
                           rect = nodeChildren.getBoundingClientRect();
                       }
                       var htmlNode = {};
                       var temp_rect = {
                           top: rect.top,
                           left: rect.left,
                           width: rect.width,
                           height: rect.height
                       };
                       htmlNode.rect = temp_rect;
                       var childPath = sugoioKit.cssPath(nodeChildren).replace(/  /g," ");
                       htmlNode.path = childPath;
                       htmlNode.classList = nodeChildren.classList;
                       var innerText =  nodeChildren.innerText || '';
                       if (innerText.length > 0) {
                           innerText = innerText.replace(/(^\s*)|(\s*$)/g, "");
                       }
                       if(innerText.length > 29){
                          htmlNode.sugo_autotrack_content = innerText.substring(0,30);
                       }else{
                          htmlNode.sugo_autotrack_content = innerText;
                       }
                       nodeJSONArray.push(htmlNode);
                       if (nodeChildren.children) {
                           sugo.handleNodeChild(nodeChildren.children, nodeJSONArray, childPath);
                       }
                   }
               };
               sugo.isVisible = function isInViewPort(el) {
                            const viewPortHeight = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
                            const top = el.getBoundingClientRect() && el.getBoundingClientRect().top;
                            return top  < viewPortHeight ;
                        };
               sugo.getSpecialElementRect = function(element) {
                  var rect = {top:0, left:0, width:0, height:0};
                  if(element.tagName == 'AREA' && element.shape == 'rect'){
                      var parentNode = element.parentNode;
                      var mapX = 0;
                      var mapTop = 0;
                      if(parentNode.tagName == 'MAP'){
                          var mapRect = parentNode.getBoundingClientRect();
                          mapTop = mapRect.top;
                          mapX =  mapRect.x;
                      }
                      var coords = element.coords;
                      var coordsArray = coords.split(',');
                      var x1 = coordsArray[0];
                      var y1 = coordsArray[1];
                      var x2 = coordsArray[2];
                      var y2 = coordsArray[3];
                      rect = {
                        top:parseInt(y1)+parseInt(mapTop),
                        left:parseInt(x1)+parseInt(mapX),
                        width:parseInt(x2-x1),
                        height:parseInt(y2-y1)
                      }
                  }
                  return rect;
               };
               sugo.reportNodes = function () {
                   var startTime = new Date().getTime();
                   var nodeJSONArray = [];
                   var body = document.getElementsByTagName('body')[0];
                   var childrens = body.children;
                   var parent_path = '';
                   sugo.clientWidth = (window.innerWidth || document.documentElement.clientWidth);
                   sugo.clientHeight = (window.innerHeight || document.documentElement.clientHeight);
                   sugo.handleNodeChild(childrens, nodeJSONArray, parent_path);
                   if (window.sugoWebNodeReporter) {
                       window.sugoWebNodeReporter.reportNodes(sugo.relative_path + (sugo.single_code ? '##' + sugo.single_code : ''), JSON.stringify(nodeJSONArray), sugo.clientWidth, sugo.clientHeight, document.title);
                   }
                   return 'ok';
               };
               sugo.getAssociatesElements = function (bindsArray = [], parentSimilarPath, s_path) {
                 s_path = s_path || '';
                 const getChildSimilarPath = (p_path, c_path) => {
                   var sameIdx = 0;
                   var dom = document.querySelector(c_path);
                   if(dom){
                       c_path = sugoioKit.entire(dom);
                   }
                   var pathLength = p_path.length;
                   var pPathList = p_path.split(' > ');
                   var cPathList = c_path.split(' > ');
                   var sPathList = s_path.split(' > ') || [];
                   var commonPathList = [];
                   if (s_path === '') {
                     commonPathList = cPathList;
                   }else {
                     for (var j = 0; j < cPathList.length; j++) {
                       if (cPathList[j]) {
                         if (pPathList[j]) {
                           if (pPathList[j].split('(')[0] === cPathList[j].split('(')[0]) {
                               if (sPathList[j].split('(')[1] && sPathList[j].split('(')[1].indexOf('n') === 0) {
                               commonPathList.push(pPathList[j]);
                             }else {
                               commonPathList.push(cPathList[j]);
                             }
                           }else {
                             commonPathList.push(cPathList[j]);
                           }
                         }else {
                           commonPathList.push(cPathList[j]);
                         }
                       }
                     }
                   }
                   var finalPath = commonPathList.join(' > ');
                   var doms = document.querySelectorAll(finalPath)|| [];
                   if (doms[0]) {
                     return finalPath;
                   }
                   for (let i = 0; i < pathLength; i++) {
                     if (p_path.charAt(i) !== c_path.charAt(i)) {
                       sameIdx = i;
                       break;
                     }
                   }
                   var similarIdex = p_path.substr(sameIdx).substring(0, p_path.substr(sameIdx).indexOf(')'));
                   var similarEndPath = c_path.substr(sameIdx).substring(c_path.substr(sameIdx).indexOf(')'));
                   return c_path.substring(0, sameIdx) + similarIdex + similarEndPath;
                 }
                 var p = {};
                 for(let i = 0; i < bindsArray.length; i++){
                     var bind = bindsArray[i];
                     let path = bind.path;
                     if (bind.similar) {
                       path = getChildSimilarPath(parentSimilarPath, path);
                     }
                     var innerText = sugo.extractElementsValue(path).join(',') || '';
                     if (innerText.length > 0) {
                         innerText = innerText.replace(/(^\s*)|(\s*$)/g, "");
                     }
                     p[bind.dimension] = innerText;
                 }
                 return p;
               };
               sugo.extractElementsValue = function (path) {
                  var values = [];
                  if (!path) {
                    return values;
                  }
                  var elems = document.querySelectorAll(path) || [];
                  for (var i = 0; i < elems.length; i++) {
                      var elem = elems[i];
                      if (elem.tagName && (elem.tagName === 'INPUT' || elem.tagName === 'SELECT')) {
                         values.push(elem.value);
                       } else if (elem.textContent) {
                         values.push(elem.textContent);
                       }else if (elem.innerText) {
                         values.push(elem.innerText);
                       }
                  }
                  return values;
               };
               sugo.delegate = function(eventType) {
                   function handle(e) {
                       var evt = window.event ? window.event : e;
                       var target = evt.target || evt.srcElement;
                       var currentTarget = e ? e.currentTarget : this;
                       var paths = Object.keys(sugo.current_event_bindings);
                       var isMatch = false;
                       for (var idx = 0; idx < paths.length; idx++) {
                           var path_str = paths[idx];
                           var event = sugo.current_event_bindings[path_str];
                           if (event.event_type != eventType) {
                               continue;
                           }
                           var path = event.path.path;
                           if (event.similar === true || event.similar === 1) {
                               path = event.similar_path ? event.similar_path : path.replace(/:nth-child\([0-9]*\)/g, '');
                           }
                           if(path && path.indexOf('icbc:') !== -1){
                                path = path.replace(/icbc:(\w+)/g, 'icbc\\:$1');
                           }
                           var eles = document.querySelectorAll(path) || [];

                           for (var eles_idx = 0; eles_idx < eles.length; eles_idx++) {
                               var ele = eles[eles_idx];
                               var parentNode = target;
                               while (parentNode) {
                                   if (parentNode === ele) {
                                       var custom_props = {};
                                       if (event.code && event.code.replace(/(^\s*)|(\s*$)/g, '') != '') {
                                           try {
                                               var sugo_props = new Function('e', 'element', 'conf', 'instance', event.code);
                                               custom_props = sugo_props(e, ele, event, sugo);
                                           } catch (e) {
                                               console.log(event.code);
                                           }
                                       }
                                       custom_props.from_binding = true;
                                       custom_props.event_type = eventType;
                                       var innerText =  ele.innerText || '';
                                       if (innerText.length > 0) {
                                           innerText = innerText.replace(/(^\s*)|(\s*$)/g, "");
                                       }
                                       if(innerText.length > 29){
                                          custom_props.event_label = innerText.substring(0,30);
                                       }else{
                                          custom_props.event_label = innerText;
                                       }
                                       custom_props.page_name = sugo.view_props["page_name"];
                                       custom_props.sugo_autotrack_path = path_str;
                                       custom_props.sugo_autotrack_page_path = sugo.relative_path;
                                       var data_code = target.getAttribute("data-code") || parentNode.getAttribute('data-code');
                                       if (data_code != null){
                                           custom_props.business_attribute = data_code;
                                       }
                                        if (event.binds) {
                                            var eventEntirePath = sugoioKit.entire(ele);
                                            var keys = Object.keys(event.binds) || [];
                                            let bindsArray = keys.map((dimension) => {
                                                var record = event.binds[dimension];
                                                return {
                                                        dimension: dimension,
                                                        path: record.path,
                                                        similar: record.similar
                                                       };
                                            });
                                            let bindProps =  sugo.getAssociatesElements(bindsArray, eventEntirePath, event.similar_path);
                                            custom_props = Object.assign(custom_props, bindProps);
                                        }
                                       sugo.rawTrack("", event.event_name, custom_props);
                                       isMatch = true;
                                       break;
                                   }
                                   parentNode = parentNode.parentNode;
                               }
                           }
                       }
                       if (isMatch || sugo.auto_track === '0') {
                             return;
                       }
                       var custom_props ={};
                       var xpath = sugoioKit.cssPath(target).replace(/  /g," ");
                       custom_props.from_binding = false;
                       custom_props.event_type = eventType;
                       custom_props.event_label = target.innerText;
                       custom_props.page_name = sugo.view_props["page_name"];

                       custom_props.sugo_autotrack_path = xpath;
                       custom_props.sugo_autotrack_page_path = sugo.relative_path;
                       var event_name = '';
                       if (target.innerText === ''){
                           var ele = target.parentNode;
                           event_name = ele.innerText;
                       } else {
                           event_name = target.innerText;
                       }
                       event_name = event_name.length > 29 ? event_name.substring(0,29) : event_name;
                       if (event_name.replace(' ', '') === ''){
                           event_name = '全埋点事件';
                       }
                       var data_code = target.getAttribute("data-code");
                       if (data_code != null){
                           custom_props.business_attribute = data_code;
                       }
                       sugo.rawTrack("", event_name, custom_props);

                   }
                   document.addEventListener(eventType, handle, true);
               };

               sugo.bindEvent = function () {
                   sugo.delegate('click');
                   sugo.delegate('focus');
                   sugo.delegate('change');
                   sugo.delegate('touchstart');
                   sugo.delegate('touchend');
               };

               if (!window.sugo) {
                   sugo.bindEvent();
               }
           sugo.registerPathName = function(){
                   var props = {};
                   if(sugo.single_code) {
                       props.path_name = sugo.relative_path + "##" + sugo.single_code;
                   } else {
                       props.path_name = sugo.relative_path;
                   }
                   window.sugoEventListener.registerPathName(props.path_name, sugo.sugo_hashcode);
               };
            sugo.registerPathName();
            sugo.init_path = function () {
                      sugo.current_page = sugo.relative_path + (sugo.single_code ? '##' + sugo.single_code : '');
                      sugo.current_event_bindings = {};
                      for (var i = 0; i < sugo.h5_event_bindings.length; i++) {
                       var b_event = sugo.h5_event_bindings[i];
                       if (b_event.target_activity === sugo.current_page || b_event.cross_page || b_event.target_activity === sugo.relative_path) {
                           var b_key = JSON.stringify(b_event.path);
                           sugo.current_event_bindings[b_key] = b_event;
                       }
                     }

                    var page_obj = sugo.all_page_info[sugo.relative_path + (sugo.single_code ? '##' + sugo.single_code : '')];
                    if(page_obj){
                    sugo.init = {
                        'code':page_obj.code,
                        'page_name': page_obj.page_name,
                        'page_category': page_obj.page_category
                    };
                   }else{
                       sugo.init = {
                            'code': '',
                            'page_name': '',
                            'page_category': ''
                       };
                   }

               };
               window.sugo = sugo;
            })(window.sugo || {});;

